/* $Id: ofwt.java,v 1.9 2010/12/09 01:24:03 mit Exp $ */
/* oscillator_wavelet.java v1.6 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class ofwt extends Applet 
    implements ActionListener, ItemListener
{ 
    private Button btoM, btoP;   // <<,>>
    private Button bttM, bttP;   // <,>
    private Button bthM, bthP;   // -,+(cent)
    private Button btGM, btGP;   // -,+(gain)
    private Button btSM, btSP;   // ><,<>
    private Button btWave;
    private Button btFwt;
    private Choice chWlet;       // wavelet
    private Choice chCent;       // cent
    private Choice chMin;        // ֹ
    private Choice chWide;       // 
    private TextField tfA;
    private Canvas can;
    private Panel PU, PD, PL, PR;
    private Label lbC, lbK;

    static final int WAVE = 0;
    static final int FWT_ = 1;
    static final int KB = 88;
    static final int OCT = 12;
    static final int AA = 440;
    static final double ML = Math.log(2)/1200/Math.log(10);
    static final double PI2 = Math.PI*2;

    static final String[] Cstep = 
    {"0.001","0.01","0.05","0.1","0.5","1.0","5.0","10.0","50.0"};  // cent    
    static final String[] Keynm =
    {"A","B","H","C","Cis","D","Es","E","F","Fis","G","Gis"};
    static final int[] R = 
    {255,255,255,255,170, 90,  0,  0,  0,  0, 40, 90, 90,170,255};
    static final int[] G = 
    {  0, 90,170,255,255,255,170,170,170, 90,  0,  0,  0,  0,  0};
    static final int[] B = 
    {  0,  0,  0,  0,  0,  0, 90,170,255,255,255,255,220,200,170};

    boolean CalSW;
    boolean CalWV;
    Color[] Octc;   // wavelet color
    double[] Sig;
    double[] Scl;
    double Wgain;   // wave
    double Gain;
    double Cby;
    double Freq;    // freq.
    double Cent;
    int W;
    int H;
    int Grap;
    int FNT;
    int SFT;
    int NK;         // key#
    int M;          // 1024:10 2048:11 4096:12 8192:13
    int J = 12;
    int Wno;        // wavelet#
    int Smplf;      // 8000 11025 22050 44100
    int Band;       // J width
    int Shift;      // J

    DecimalFormat df1;
    Graphics gi;
    Image im;
    Font Fnt;
    FontMetrics fm;
    FWT FW;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);

	df1 = new DecimalFormat("#0.0#");
	setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	
	PU = new Panel();
	PU.setLayout(new GridLayout(2,1,0,0));
	add("North", PU);
	
	Panel uu = new Panel();
	uu.setLayout(new FlowLayout());
	PU.add(uu);
	
	Panel ud = new Panel();
	ud.setLayout(new FlowLayout());
	PU.add(ud);

	tfA = new TextField(28);
	tfA.setEditable(false);
        uu.add(tfA);

	FW = new FWT();
	chWlet = new Choice();
	for (int i = 0; i < FW.getWaveletsNum(); i++)
	    chWlet.addItem(FW.getWaveletsName(i));
	chWlet.select(Wno);
 	chWlet.addItemListener(this);
        uu.add(chWlet);
	//- uu

	lbK = new Label("_______", Label.RIGHT);
	ud.add(lbK);

	bttM = new Button("<<");
        bttM.addActionListener(this);
        ud.add(bttM);

	btoM = new Button("<");
        btoM.addActionListener(this);
        ud.add(btoM);

	btoP = new Button(">");
        btoP.addActionListener(this);
        ud.add(btoP);

	bttP = new Button(">>");
        bttP.addActionListener(this);
        ud.add(bttP);

	lbC = new Label(Cent+"[cent]", Label.RIGHT);
	ud.add(lbC);

	bthM = new Button("-");
        bthM.addActionListener(this);
        ud.add(bthM);

	bthP = new Button("+");
        bthP.addActionListener(this);
        ud.add(bthP);

	chCent = new Choice();
        for (int i = 0; i < Cstep.length; i++)  // cent
            chCent.addItem(Cstep[i]);
        ud.add(chCent);
        chCent.addItemListener(this);
        chCent.select("1.0");
        Cby = 1.0;
	//-------------------- north

	PL = new Panel();
	PL.setLayout(new GridLayout(6,1,0,0));
	add("West", PL);

	btWave = new Button("Wave");
	btWave.addActionListener(this);
	PL.add(btWave);

	btFwt = new Button("Fwt");
	btFwt.addActionListener(this);
	PL.add(btFwt);

	PL.add(new Label("Start:"));

	chMin = new Choice();
	for (int i = 1; i < J; i++) // 1~
	    chMin.addItem(""+i);
        chMin.addItemListener(this);
        PL.add(chMin);

	PL.add(new Label("Wide:"));

	chWide = new Choice();
	for (int i = 2; i < J; i++) // 2~
	    chWide.addItem(""+i);
	chWide.select(""+(J-1));
        chWide.addItemListener(this);
        PL.add(chWide);
	//------------------ west

	PR = new Panel();
        PR.setLayout(new GridLayout(5,1,0,0));
        add("East", PR);

	btGP = new Button("+");
        btGP.addActionListener(this);
        PR.add(btGP);

	btGM = new Button("-");
        btGM.addActionListener(this);
        PR.add(btGM);

	PR.add(new Label());

	btSM = new Button("<");
        btSM.addActionListener(this);
        PR.add(btSM);
	
	btSP = new Button(">");
        btSP.addActionListener(this);
        PR.add(btSP);
	//--------------------- east

	can = new MyCanvas();
	add(can, "Center");

	init_start();
    }
    public void start() {
	W = getCanvasD().width;
	H = getCanvasD().height;

	can.setSize(W, H);
	im = createImage(W, H);
        gi = im.getGraphics();
        gi.setFont(Fnt);
	fm = getFontMetrics(Fnt);
	SFT = fm.stringWidth("(00000)");
	Wgain = H/4.0;
    }
    public Dimension getCanvasD() {
        Dimension dn = PU.getSize();
	Dimension de = PR.getSize();
	Dimension dw = PL.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-dn.height;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void init_start() {
	M = (int)Math.pow(2, J);
	Band = J;
	Shift = 0;
	Smplf = 44100;
	Sig = new double[Smplf];
	Gain = 4.0/Short.MAX_VALUE;
	NK = OCT*4;
	Wno = 0;
	Grap = WAVE;

	ch_wavelet();
	set_m();
	set_freq();
	set_color();
    }
    public void set_color() {
	Octc = new Color[G.length];
	for (int i = 0; i < G.length; i++)
	    Octc[i] = new Color(R[i], G[i], B[i]);
    }
    //
    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == chWlet) {  // choice wavelet
	    Wno = chWlet.getSelectedIndex();
	    ch_wavelet();

	    can.repaint();
	}

	if (e.getSource() == chCent) { // cent
	    String hn = chCent.getSelectedItem();
            Cby = Double.valueOf(hn).doubleValue();

	    CalWV = false;
        }

	if (e.getSource() == chMin)
	    set_min();

	if (e.getSource() == chWide)
	    set_wide();
    }
    //
    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btWave)
	    Grap = WAVE;
	else if (e.getSource() == btFwt)
	    Grap = FWT_;

	else if (e.getSource() == btoM)
	    set_key(-1);
	else if (e.getSource() == bttM)
	    set_key(-OCT);
	else if (e.getSource() == btoP)
	    set_key(1);
	else if (e.getSource() == bttP)
	    set_key(OCT);

	else if (e.getSource() == bthM)
	    set_c(false);
	else if (e.getSource() == bthP)
	    set_c(true);

	else if (e.getSource() == btSM) {  // scale
	    M /= 2;
	    set_m();
	} 
	else if (e.getSource() == btSP) {
	    M *= 2;
	    set_m();
	}

	else if (e.getSource() == btGM)    // gain
	    set_volume(false);
	else if (e.getSource() == btGP)
	    set_volume(true);

	can.repaint();
    }
    //
    public void set_volume(boolean sw) {
	double sq2 = Math.sqrt(2);

	switch (Grap) {
	case WAVE:
	    Wgain = sw ? Wgain*sq2 : Wgain/sq2;
	    break;
	case FWT_:
	    Gain = sw ? Gain*sq2 : Gain/sq2;
	    break;
	default:
	}
    }
    public void set_sp() {
	if (Smplf > 44000)
	    J = 15;
	 else if (Smplf > 22000)
	    J = 14;
	 else if (Smplf > 11000)
	    J = 13;
	 else
	    J = 12;
	M = (int)Math.pow(2, J);
	set_m();
    }	

    public void set_m() {
	if (M < 1000) {
	    M = (int)Math.pow(2, 10);
	    btSM.setEnabled(false);
	} else if (M > Smplf) {
	    M /= 2;
	    btSP.setEnabled(false);
	} else {
	    btSM.setEnabled(true);
	    btSP.setEnabled(true);
	}

	CalSW = false;
    }
    //
    public void set_c(boolean sw) {
	Cent = sw ? Cent+Cby : Cent-Cby;

	set_freq();
    }
    public double ctof(double f, double c) {
        return f*Math.pow(10, c*ML);
    }
    public void set_freq() {
	Freq = ctof(getFreq(NK), Cent);
	lbC.setText(Cent+"[cent]");
	lbK.setText((NK+1)+"<"+Keynm[NK%OCT]+">");

	CalWV = false;
    }
    public void set_key(int k) {
	NK += k;
        if (NK < 0)
            NK += KB;     // min 0
        else if (NK > KB-1)
            NK -= KB;     // max KB-1

	set_freq();
    }
    public double getFreq(int key) {
	return AA*Math.pow(2, (key-48)/(double)OCT); // 49-1
    }
    public void makewave() {
	double td = 1.0/Smplf;
	double t = 0;

	for (int i = 0; i < Smplf; i++) {
	    Sig[i] = Math.sin(PI2*Freq*t);
	    t += td;
	}

	CalWV = true;
	CalSW = false;
    }
    public void set_wide() {
	Band = chWide.getSelectedIndex()+2;

	can.repaint();
    }
    public void set_min() {
	Shift = chMin.getSelectedIndex();

	can.repaint();
    }
    public void ch_wavelet() {
	FW.setFWT(Wno);

	CalSW = false;
    }
    public double set_gain(int j) {
	double by = j+1;            // daub
	if (Wno > 9)
	    by = Math.pow(2,j)*2;   // symlet,harr
	else if (Wno > 4)
	    by = 1;                 // coiflet

	return Gain*8.0/by;
    }
    public void write_tfa() {
	StringBuffer str = new StringBuffer();

	switch (Grap) {
	case WAVE:
	    str.append(Smplf+"[Hz]: 1.0[sec]");
	    break;
	case FWT_:
	    str.append(df1.format(100.0*M/Smplf)+"% (");
	    str.append(M+"/");
	    str.append(Smplf+") ");
	    str.append(df1.format(Freq)+"[Hz]");
	    break;
	default:
	}

 	tfA.setText(str.toString());
    }
    //-----

    class MyCanvas extends Canvas {
        public void update(Graphics g) {
            can.paint(g);
        }
	public void paint(Graphics g) {
	    paintI();
            g.drawImage(im, 0, 0, this);
        }
    }
    public void paintI() {
	gi.setColor(Color.black);
	gi.fillRect(0, 0, W, H);

	if (!CalWV)
	    makewave();
	disp_sft_line(gi);
	write_tfa();

	switch (Grap) {
	case WAVE:
	    disp_wave(gi);
	    break;
	case FWT_:
	    disp_wavelet(gi);
	    disp_smpl(gi);
	    break;
	default:
	}
    }
    public void disp_sft_line(Graphics g) {
	gi.setColor(Color.gray);
	gi.drawLine(SFT, 0, SFT, H);
    }
    public void disp_smpl(Graphics g) {
	gi.setColor(Color.yellow);
	gi.drawString(""+Smplf, 2, FNT);
    }
    public void disp_wavelet(Graphics g) {
	if (!CalSW) {
	    int[] temp = new int[Sig.length];
	    for (int i = 0; i < Sig.length; i++)
		temp[i] = (int)(Sig[i]*Short.MAX_VALUE/2);
	    FW.wavelet(temp, M, J, 0);
	    CalSW = true;
	}

	int h0 = H/(Band+1);
	int ba = Band+Shift;
	if (ba > J) {
	    ba = J;
	    h0 = H/(J-Shift);
	}

	int sj = Smplf/(int)Math.pow(2, Shift+1);
	int h1 = 0, lj, x1, y1;
	double dx, ga;
	for(int j = Shift; j < ba; j++) {
	    lj = M/(int)Math.pow(2, j+1);
	    dx = (double)(W-SFT)/lj;
	    h1 += h0;
	    sj /= 2;
	    disp_j_line(g, j, sj, h1);

	    ga = set_gain(j);
	    g.setColor(Octc[j]);
	    for(int i = 0; i < lj; i++) { // disp wavelet
		x1 = (int)(SFT+i*dx);
		y1 = (int)(h1-FW.getData(i+lj)*ga);
		gi.drawLine(x1, h1, x1, y1);
	    }
	}
    }
    public void disp_j_line(Graphics g, int j, int sj, int h1) {
	gi.setColor(Color.white);       // J
	gi.drawString(""+(j+1), 0, h1);

	gi.setColor(Color.orange);      // octave
	gi.drawString(""+sj, 0, h1+FNT);

	gi.setColor(Color.gray);        // line
	gi.drawLine(0, h1, W, h1);
    }
    //
    public void disp_wave(Graphics g) {
	int h2 = H/2, x0, y0;
	double dw = (W-SFT)/(double)M;

	g.setColor(Color.gray);
	g.drawLine(0, h2, W, h2);

	g.setColor(Color.green);
	for(int i = 0; i < M; i++) {
	    x0 = (int)(SFT+dw*i);
	    y0 = (int)(h2-Sig[i]*Wgain);
	    g.drawLine(x0, y0, x0, y0);
	}
    }
}

